<?php

namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

class BrowseController extends AppController
{

    private $coverUrl;
    private $useUpload;

    private $doc_title;

    public function initialize(): void
    {
        parent::initialize();

        $this->coverUrl = Configure::read('CoverUrl');
        $this->useUpload = Configure::read('Upload.Use');
        $this->doc_title = "選曲";
    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'cover_url', $this->coverUrl );
        $this->set( 'useUpload', $this->useUpload );
        $this->set( 'title', $this->doc_title );
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index( ) {
        $this->doc_title = "トップ";
    }


    public function browse( $dir = "", $dir2 = "" ) {	//	リスト
//        Log::write( 'debug', "browse: {$dir} ： {$dir2}" );
        $this->set('orgdir', $dir );
        $this->set('orgdir2', $dir2 );
//        $dir = urldecode( $dir );
//        Log::write( 'debug', "after: {$dir}" );

        $tabstr_back = "";
        $this->set('dir', $dir );
        $dir2 = trim( $dir2 );
        $this->set('dir2', $dir2 );
        $cmds = explode( ':', $dir2 );
        if ( count( $cmds ) == 2 ) {
            $cmd = $cmds[ 0 ];
            $parm = $cmds[ 1 ];
            switch ($cmd) {
                case 'go':
                    $tabstr_go = trim($parm);
                    if (preg_match("/nm[0-9]+/", $tabstr_go ) == 1 ) {
                        $tabstr_back = $tabstr_go;
                    } else {
                        $tabstr_back = "";
                    }
                    break;

                case 'bk':
                    $tabstr_bk = trim($parm);
                    if (preg_match("/nm[0-9]+/", $tabstr_bk ) == 1 ) {
                        $tabstr_bkary = preg_split( "/_/", $tabstr_bk );
                        $tabstr_bkstr = array_pop($tabstr_bkary);
                        $tabstr_back = implode("_", $tabstr_bkary );
                    } else {
                        $tabstr_back = "";
                    }
                    break;

                default:
                    break;
            }
        }

        //	戻り先
//		$dir = urldecode( $dir );

        //  現在のパス表示
        $this->doc_title .= "：{$dir}";

        $this->set('backdir', dirname($dir) );
        $this->set('fradddir', $dir );

        $drlist = $this->Mpd->getInfo( $dir );
        $this->set( 'drlist_base', $drlist );

        $hvdir = $hvsng = false;

        if ( isset($drlist['directory']) && isset($drlist['file']) ) {
            $hvdir = $hvsng = true;
            $tp = 'browseboth';
        } else {
            if ( isset($drlist['directory']) ) {
                $hvdir = true;
                $tp = 'browse';
            } elseif ( isset($drlist['file']) ) {
                $hvsng = true;
                $tp = 'browsesong';
            } else {
                $this->set('drlist', [ ] );
                $tp = 'browse';
            }
        }

        if ( $hvdir ) {
            $dd = $drlist['directory'];
            sort($dd);
            $dparm = [ ];
            foreach ($dd as $value) {
                $dnary = explode("/", $value );
                $dparm[] = [ array_pop( $dnary ), $value ];
            }
            $this->set('drlist', $dparm );
        } else {
            $this->set('drlist', [ ] );
        }
        if ( $hvsng ) {
            $this->set('songlist', $drlist['file'] );
        } else {
            $this->set('songlist', [ ] );
        }

        if ($dir=="") {
            $title = "ルート";
        } else {
//			$lst = explode("/",$dir);
//			$title = array_pop($lst);
            $title = $dir;
        }

        $this->set( 'tabstr_base', $tabstr_back );
//        $this->set( 'title', $title );
        $this->doc_title = $title;

//		$this->render( $tp );

    }

}
