<?php


namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

class FavoritesController extends AppController
{

    private $doc_title;

    public function initialize(): void
    {
        parent::initialize();


        $this->doc_title = "お気に入りリスト";
    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'title', $this->doc_title );
    }

    public function index( ) {
        $plst = $this->Mpd->getPlaylists();
        $this->set('plst', $plst );

    }

    public function play( $dir = '' ) {
        $dir = urldecode( trim( $dir ) );
//        Log::write( 'debug', "play: {$dir}" );
        if ( $dir == "" ) $this->redirect ( [ 'action' => 'index' ] );
        $plst = $this->Mpd->loadPlaylists( $dir );
        $this->set('dir', $dir );
        $this->set('plst', $plst );
        $this->render("debug");
    }

    public function detail( $dir = '' ) {
        $dir = urldecode( trim( $dir ) );
        if ( $dir == "" ) $this->redirect ( [ 'action' => 'index' ] );
        $plst = $this->Mpd->getPlaylistDetail( $dir );
        $this->set('dir', $dir );
        $this->set('plst', $plst );
    }

}
