<?php
/*

	Takeo Akiyama, Fourthgate Inc.

	mpcbridge Ver. 6.1 / 2021.04.03

 */

namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

class LabelController extends AppController
{


    private $coverUrl;
    private $alphabet;
    private $alphabetgrid;
    private $songs;
    private $albums;
    private $favolabel;

    public function initialize(): void
    {
        parent::initialize();

        $this->albums = TableRegistry::getTableLocator()->get('Albums');
        $this->songs = TableRegistry::getTableLocator()->get('Songs');
        $this->favolabels = TableRegistry::getTableLocator()->get('Favolabels');

        $this->coverUrl = Configure::read('CoverUrl');
        $this->alphabet = Configure::read('alphabet');
        $this->alphabetgrid = Configure::read('alphabetgrid');
        $this->doc_title = "選曲";
    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'cover_url', $this->coverUrl );
        $this->set( 'alphabet', $this->alphabet );
        $this->set( 'alphabetgrid', $this->alphabetgrid );
        $this->set( 'title', $this->doc_title );
    }

    public function index( ) {
        $myLabels = $this->favolabels->find( )->where(['Favolabels.label_key >' => 1 ])->order( [ 'Favolabels.id' => 'ASC' ] )->all( );
        $this->set( 'labels', $myLabels );
        $this->doc_title = "ラベル";
    }


    public function albumlist( $lid = 0, $srtkey = 0 ) {
        $lid = intval( $lid );
        if ( $lid == 0 ) $this->redirect( [ 'action'=>'index' ] );
//		$label = $this->favolabels->get( $lid );
        $label = $this->favolabels->find()->where( [ 'label_key' => $lid ] )->first( );

        if ( ! $label ) return $this->redirect( [ 'action'=>'index' ] );


        $query = $this->albums->find( )->contain( [ 'Songs' ] );
        $query->where( [ 'Albums.favolabels_key' => $lid ] );

        if ( $srtkey == 0 ) {
            //	発表年
            $query->order( [ "IF(Albums.release_date = NULL, '0000', Albums.release_date) ASC", ] );
        } else {
            $query->order( [ "IF(Albums.release_date = NULL, '0000', Albums.release_date) DESC",  ] );
        }
        $all_songs = $query->all( );

        if ( ! $all_songs ) $this->redirect( [ 'action'=>'index' ] );


        $alllabels = $this->_labels( );
        $this->set( 'labelcolor', $alllabels );
        $this->set( 'labelname', $label['colorname'] );
        $this->set( 'albums', $all_songs );

        $this->set( 'lid', $lid );
        $this->set( 'srtkey', $srtkey );

        $this->set( 'lbldat', $label );

    }


    function _labels ( ) {

        $lblall = $this->favolabels->find( )->order( [ 'Favolabels.label_key' => 'ASC' ] )->all( );
        if ( $lblall !== FALSE ) {
            $a1 = $a2 = array();
            foreach ( $lblall as $value ) {
                $a1[$value->label_key] = $value->colorcode;
                $a2[$value->label_key] = $value->colorname;
            }
            $retval = array(
                0 => $a1,
                1 => $a2
            );
        } else {
            $retval = array(
                0 => array( 1 => "808080" ),
                1 => array( 1 => "ラベルなし" )
            );
        }
        return $retval;
    }

}
