<?php
/*

	Takeo Akiyama, Fourthgate Inc.

 */


namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

class RadiosController extends AppController
{

    private $netradio;
//	private $subnetradio;
    private $coverUrl;	//	互換性のため
    private $uploadMethod;
    private $playMethod;

    private $doc_title;

    public function initialize(): void
    {
        parent::initialize();


        $this->netradio = TableRegistry::getTableLocator()->get('Netradios');
//		$this->subnetradio = TableRegistry::get('Netradiosubs');
        $this->coverUrl = Configure::read('CoverUrl');	//	互換性のため
        $this->uploadMethod = Configure::read('Upload.RadioMethod');
        $this->playMethod = Configure::read('Upload.Method');

        $this->doc_title = "ネットラジオ";
    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'cover_url', $this->coverUrl );
        $this->set( 'uploadMethod', $this->uploadMethod );
        $this->set( 'playMethod', $this->playMethod );
        $this->set( 'title', $this->doc_title );
    }

    public function index( ) {	//	radio曲リスト

        $query = $this->netradio->find( );
        $radiolist = $query->order( [ "Netradios.title" => "ASC" ] )->all( );

        if ( $radiolist === false ) {
            $this->set( 'radiolist', array( ) );
        } else {
            $this->set( 'radiolist', $radiolist );
        }

    }


    public function stream ( $id = 0 ) {

        $btn = $this->request->getData( 'sending', '' );
        $id = $this->request->getData( 'id', 0 );
        $radiourl = $this->request->getData( 'radiourl', '' );
        $play_method = $this->request->getData( 'play_method', 0 );
        $addlist = $this->request->getData( 'addlist', 0 );
        if ( $this->request->is( [ 'post', 'put' ] ) ) {
            Log::write( 'debug', "stream getData: ". print_r( $this->request->getData( ), true ) );

            if ( $id > 0 ) {
                $entity = $this->netradio->get( $id );
                if ( $entity == null ) return $this->redirect( [ 'action' => 'index' ] );

            } else {
                $entity = $this->netradio->newEmptyEntity( );
            }
            $entity = $this->netradio->patchEntity( $entity, $this->request->getData( ) );
            if ( $entity->title == "" ) $entity->title = $entity->radiourl;
            Log::write( 'debug', "stream entity: ". print_r( $entity, true ) );

            if ( ! $entity->getErrors( ) ) {
                //  再生
                if ( $addlist == 1 ) {
                    //	保存？
                    $this->netradio->save( $entity );
                    Log::write( 'debug', "stream entity after save: ". print_r( $entity, true ) );
                    $this->set( 'datas', $entity );
                    $this->Flash->set( $radiourl ."を更新しました" );
                }
                //  ストリーム再生
                if ( $play_method == 0 ) $go = $this->Mpd->clear( );
                $rdo = $this->Mpd->addSong( $radiourl );
                $this->Flash->set( $radiourl ."を再生リストに追加しました" );
                $this->redirect( [ 'action' => 'index' ] );
            }
        } else {
            //	なにもpostされていない
            $entity = $this->netradio->newEmptyEntity( );
            $id = intval($id);
            if ( $id > 0) {
                if ( $data = $this->netradio->get( $id ) ) {
                    $entity = $data;
                } else {
                    $this->redirect( [ 'action' => 'index' ] );
                }
            }

        }
        $this->set( 'entity', $entity );

    }

    public function delete( $id = 0 ) {
        if ( $id == 0 ) {
            $flashMsg = "不正なアクセスです（ID未指定）";
        } else {
            $radio = $this->netradio->get($id);
            if ( ! is_null( $radio ) ) {
                if ($this->netradio->delete($radio)) {
                    $flashMsg = "ネットラジオを削除しました";
                } else {
                    $flashMsg = "ネットラジオ削除に失敗しました";
                }
            } else {
                $flashMsg = "該当するネットラジオが見つかりません";
            }
        }
        $this->Flash->set( $flashMsg );
        return $this->redirect(['action' => 'index']);
    }
}
