<?php
/*

	Takeo Akiyama, Fourthgate Inc.

 */


namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

class SettingController extends AppController
{

	private $mpdstats;

    private $doc_title;

	public function initialize(): void
	{
		parent::initialize();

		$this->mpdstats = TableRegistry::getTableLocator()->get('Mpdstats');
		$this->favolabels = TableRegistry::getTableLocator()->get('Favolabels');

        $this->doc_title = "設定";
	}


	public function beforeRender(\Cake\Event\EventInterface $event) {
		parent::beforeRender($event);
		$this->set( 'version', Configure::read('thisVersion') );
        $this->set( 'title', $this->doc_title );
	}


	public function index( ) {

	}


	public function sortorder( ) {

	}


	public function about( ) {

		$stats = $this->Mpd->getStats( );
        $status = $this->Mpd->getStatus( );

		$mpdstats = $this->mpdstats->find( )->order( [ 'Mpdstats.id' => 'ASC' ] )->first( );

		$dbmatch = false;
		if ( isset( $mpdstats->lastdates ) && ( $mpdstats->lastdates == $stats['stats']['db_update'] ) ) $dbmatch = true;


		$this->set('dbmatch', $dbmatch );
		$this->set('stats', $stats );
		$this->set('mpdstats', $mpdstats );
        $this->set('status', $status );
        $this->set('mpd_version', $this->Mpd->getVersion() );

	}


	public function dbupdate( ) {

		$drlist = $this->Mpd->getInfo( );
		$this->set('drlist', $drlist );

	}

	public function godbupdate( ) {
        $dr = $this->request->getQuery( 'dr', "" );
		$dr = trim($dr);
		$drlist = $this->Mpd->getInfo( );
		if ( isset($drlist['directory']) && in_array( $dr, $drlist['directory'] ) ) {
			$this->Mpd->updateDatabase( $dr );
		} else {
            $this->Mpd->updateDatabase( );
		}

	}


    public function outputs( ) {

        $dvlist = $this->_getOutputs();

        $this->set('dvlist', $dvlist );
    }


	public function songinfo( ) {

	}


	public function playmode( ) {
        $status = $this->Mpd->getStatus( );
        $this->set('status', $status );
        $this->set( 'repeatMode', Configure::read('repeatMode') );
        $this->set( 'randomMode', Configure::read('randomMode') );

    }


	public function labellist( ) {

		$query = $this->favolabels->find( )->where( [ 'NOT' => [ 'Favolabels.colorname' => 'ラベルなし' ] ])->order( [ 'Favolabels.id' => "ASC" ] );
		$data = $query->all( );
		if ( $data === FALSE ) $this->redirect( [ 'action' => 'index' ] );

		$this->set( 'labels', $data );

	}


	public function labeledit( $id = 0 ) {
	    try {
            $entity = $this->favolabels->get( $id );
            if ( $this->request->is( [ 'post', 'put' ] ) ) {
//                Log::write( 'debug', 'labeledit $entity : ' . print_r( $entity, true ) );
                $entity = $this->favolabels->patchEntity( $entity, $this->request->getData( ) );
                if ( ! $entity->getErrors( ) ) {
                    //	保存？
//                    Log::write( 'debug', '$entity : ' . print_r( $entity, true ) );
                    $this->favolabels->save( $entity );
                    $this->set( 'datas', $entity );
                    return $this->redirect( [ 'action'=>'labellist' ] );
                } else {
//                    $this->set( 'err', $this->favolabels->validationErrors );
                }
            }
            $this->set( 'entity', $entity );
        } catch ( NotFoundException $e ) {
//            Log::write( 'debug', 'labeledit notfound : ' . print_r( $entity, true ) );
        }

	}


    public function setrepeat( ) {
        $retval = $val = intval( $this->request->getQuery('rpt' ,0 ) );

        switch ($val) {
            case 2:
                $rp = 1;
                $sg = 1;
                break;
            case 1:
                $rp = 1;
                $sg = 0;
                break;

            default:
                $rp = 0;
                $sg = 0;
                $retval = 0;
                break;
        }

        $this->Mpd->single( $sg );
        $this->Mpd->repeat( $rp );

        $this->viewBuilder()->setLayout( FALSE );
        $this->set('retval', $retval );
        $this->render( "outout" );
    }


    public function setrandom( ) {
        $val = $this->request->getQuery('rdm', 0 );
        if ( ($val!=0) && ($val!=1) ) $val = 0;

        $pl = $this->Mpd->getStatus( );
        if ( $val == 1 ) {
            if ( $pl['status']['repeat'] == 1 ) {
                //  random on の場合は、repeatをオフに
                if ( $pl['single'][0] == 1 ) $this->setrepeat( 0 );
            }
        }
        $this->Mpd->random( $val );

        $this->viewBuilder()->setLayout( FALSE );
        $this->set('retval', $val );
        $this->render( "outout" );
    }


	function _getOutputs( ) {	//	出力デバイスのリストを取得
		$dv = $this->Mpd->getOutputs( );

		$dvlist = array();
		if (count($dv['outputs'])>0) {
			$k = 0;
			for ( $i = 0; $i < count($dv['outputs']); $i = $i + 2 ) {
				$dvlist[ $dv['outputs'][$i]['outputid'] ] = array(
									'outputid' => $dv['outputs'][$i]['outputid'],
									'outputname' => $dv['outputs'][$i+1]['outputname'],
									'outputnamealpha' => preg_replace('/[^0-9a-zA-Z]/', '', $dv['outputs'][$i+1]['outputname']),
									'outputenabled' => $dv['outputs'][$i+1]['outputenabled'],
								);
				$k ++;
			}
		}

		return($dvlist);
	}

}
