<?php
/*

	Takeo Akiyama, Fourthgate Inc.

	mpcbridge Ver. 6.1 / 2021.04.03

*/
declare(strict_types=1);

namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;

use App\Controller\Component\RequestHandler;
use Cake\ORM\TableRegistry;
use Cake\Routing\Router;
use Cake\Log\Log;

use App\Form\PlaylistForm;

class TopController extends AppController
{


    public function initialize(): void
    {
        parent::initialize();
        $this->loadComponent('RequestHandler');

    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'cover_url', Configure::read('CoverUrl') );
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index( ) {
        $this->viewBuilder()->disableAutoLayout();

        $entity = new PlaylistForm();
        $this->set( 'entity', $entity );

        $this->set('status', $this->Mpd->getStatus( ) );

        $this->set('stats', $this->Mpd->getStats( ) );

        $this->set('getCurrentSong', $this->Mpd->getCurrentSong( ) );
    }

    public function manifest( ) {
        $this->RequestHandler->renderAs($this, 'json');
        $this->response->withType('application/json');
        $this->set('short_name', "mpcbridge" );
        $this->set('name', "mpcbridgeホーム" );
        $this->set('start_url', Router::url( "/" ) );
        $this->set('display', "standalone" );
        $this->set('background_color', "#222222" );
        $this->set('icons', [
            [
                "src" => Router::url( "/icon-1x.png" ),
                "type" => "image/png",
                "sizes" => "48x48"
            ],
            [
                "src" => Router::url( "/icon-2x.png" ),
                "type" => "image/png",
                "sizes" => "96x96"
            ],
            [
                "src" => Router::url( "/icon-4x.png" ),
                "type" => "image/png",
                "sizes" => "192x192"
            ]
        ] );
//        $this->set( '_serialize', [ 'short_name', 'name', 'display', 'background_color', 'icons', 'start_url' ] );
        $this->viewBuilder()->setOption('serialize', [ 'short_name', 'name', 'display', 'background_color', 'icons', 'start_url' ]);

    }

    /**
     * Index method
     *
     * @return void
     */
    public function index2( ) {
        $entity = new PlaylistForm();
        $this->set( 'entity', $entity );

//        $this->viewBuilder()->setLayout( '' );

        $genres = TableRegistry::getTableLocator()->get('Genres');

        $getCurrentSong = $this->Mpd->getCurrentSong( );
        $this->set('getCurrentSong', $getCurrentSong );
        $this->set('genres', $genres->find('Sorted')->all( ) );
    }

}
