<?php

namespace App\Controller;

use App\Controller\AppController;
use Cake\Event\Event;
use Cake\Core\Configure;
use Cake\ORM\TableRegistry;
use App\Controller\Component\RequestHandler;
use Cake\Network\Request;
use Cake\Log\Log;

use App\Form\UploadsForm;

class UploadController extends AppController
{

    private $useMpc;
    private $cmd;
    private $uploadPath;
    private $uploadMethod;

    private $doc_title;

    public function initialize(): void
    {
        parent::initialize();

        $useUpload = Configure::read('Upload.Use');
        if ( ! $useUpload ) $this->redirect( [ 'controller' => 'browse', 'action' => 'index' ] );
        $mpdHost = Configure::read('Mpd.host');
        if ( $mpdHost != 'localhost' ) $this->redirect( [ 'controller' => 'browse', 'action' => 'index' ] );


        $this->uploadPath = Configure::read('Upload.Path');
        $this->uploadMethod = Configure::read('Upload.Method');
        $this->cmd = Configure::read('mpcCommand.Cli');
        $this->useMpc = Configure::read('mpcCommand.Use');

        $this->doc_title = "アップロード";
    }

    public function beforeRender(\Cake\Event\EventInterface $event) {
        parent::beforeRender($event);

        $this->set( 'uploadPath', $this->uploadPath );
        $this->set( 'uploadMethod', $this->uploadMethod );
        $this->set( 'command', $this->cmd );
        $this->set( 'title', $this->doc_title );
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index( ) {
        if ( ! $this->useMpc ) $this->redirect( [ 'action' => 'nompc' ] );
        $entity = new UploadsForm();
        $this->set( 'entity', $entity );

        if ( $this->request->is('post') ) {
            $data = $this->request->getData( );
            $isValid1 = $entity->validate( $data );
            if ( $isValid1 ) {

                $sgfile = $this->uploadPath . $data['upload_file']['name'];
                $res = move_uploaded_file( $data['upload_file']['tmp_name'], $sgfile );
                if ( $res ) {
                    //	0の場合、クリア
                    if ( $data['play_method'] == "0" ) $dmy = exec( "{$this->cmd} clear" );

                    //	ファイル再生
                    $sgfile = ' "'.str_replace('"', '\"', $sgfile) .'"';
                    $tgt = 'file://'. $sgfile;
                    $out = exec( $this->cmd ." add ". $sgfile );
                    $this->Flash->set( $sgfile ."を再生リストに追加しました" );
                }
            }

        }
    }

    public function nompc( ) {

    }

}
