<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace App\Form;

use Cake\Core\Configure;
use Cake\Form\Form;
use Cake\Form\Schema;
use Cake\Validation\Validator;

class UploadsForm extends Form
{

	protected function _buildSchema(Schema $schema) : Schema
    {
		$schema->addField( 'play_method', ['type' => 'string'] );
		$schema->addField( 'upload_file', ['type' => 'file'] );

		return $schema;
	}

    public function validationDefault(Validator $validator) : Validator
    {
		$allowExts = Configure::read('Upload.Exts');
		$validator->setProvider('fext', 'App\Model\Validation\UpfileValidation');

		$validator->allowEmptyString( 'play_method' );

		$validator->add( 'play_method', 'num', [
								'rule' => [ 'inList', [ "0", "1" ] ],
								'message' => 'いずれかを選んでください'
					 ]);

        $validator
			->add( 'upload_file', [
				'fileSize' => [
						'rule' => ['fileSize', '<', '100MB'],
						'message' => 'ファイルサイズは1GB以下にしてください',
						'last' => TRUE,
					],
				'extension' => [
						'rule' => [ 'extension', $allowExts ],
						'message' => '未対応のファイル形式です'
					]
			]);

		return $validator;
	}

/*
	public function setErrors($errors) {
		$this->_errors = $errors;
	}
*/

	protected function _execute(array $data) : bool
    {
        return true;
	}

}
