<?php
declare(strict_types=1);

namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * Album Entity
 *
 * @property int $id
 * @property \Cake\I18n\FrozenTime|null $created
 * @property \Cake\I18n\FrozenTime|null $modified
 * @property int $favolabels_key
 * @property string|null $albumtitle
 * @property string|null $albumtitle_sort
 * @property string|null $artist
 * @property string|null $artist_sort
 * @property string|null $genre
 * @property string|null $path
 * @property \Cake\I18n\FrozenDate|null $release_date
 * @property int|null $songs_count
 * @property string|null $musicbrainz_albumid
 *
 * @property \App\Model\Entity\Favolabel $favolabel
 * @property \App\Model\Entity\Song[] $songs
 */
class Album extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'created' => true,
        'modified' => true,
        'favolabels_key' => true,
        'albumtitle' => true,
        'albumtitle_sort' => true,
        'artist' => true,
        'artist_sort' => true,
        'genre' => true,
        'path' => true,
        'release_date' => true,
        'songs_count' => true,
        'musicbrainz_albumid' => true,

        'favolabel' => true,
        'songs' => true,
    ];
}
