<?php
declare(strict_types=1);

namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * Song Entity
 *
 * @property int $id
 * @property \Cake\I18n\FrozenTime|null $created
 * @property \Cake\I18n\FrozenTime|null $modified
 * @property int $albums_id
 * @property string|null $file
 * @property string|null $path
 * @property string|null $title
 * @property int|null $length
 * @property string|null $artist
 * @property string|null $artist_sort
 * @property string|null $composer
 * @property string|null $composer_sort
 * @property string|null $genre
 * @property int|null $track
 * @property \Cake\I18n\FrozenDate|null $songdate
 * @property string|null $albumtitle
 * @property string|null $albumtitle_sort
 * @property string|null $album_artist
 * @property string|null $album_artist_sort
 * @property string|null $fileformat
 * @property \Cake\I18n\FrozenTime|null $last_modified
 * @property string|null $performer
 * @property string|null $conductor
 * @property string|null $label
 * @property string|null $musicbrainz_artistid
 * @property string|null $musicbrainz_albumid
 * @property string|null $musicbrainz_albumartistid
 * @property string|null $musicbrainz_trackid
 * @property string|null $musicbrainz_releasetrackid
 * @property string|null $musicbrainz_workid
 * @property string|null $sampling_frequency
 * @property int|null $quantization_bits
 * @property string|null $channels
 * @property string|null $dsd_rate
 *
 * @property \App\Model\Entity\Album $album
 */
class Song extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'created' => true,
        'modified' => true,
        'albums_id' => true,
        'file' => true,
        'path' => true,
        'title' => true,
        'length' => true,
        'artist' => true,
        'artist_sort' => true,
        'composer' => true,
        'composer_sort' => true,
        'genre' => true,
        'track' => true,
        'songdate' => true,
        'albumtitle' => true,
        'albumtitle_sort' => true,
        'album_artist' => true,
        'album_artist_sort' => true,
        'fileformat' => true,
        'last_modified' => true,
        'performer' => true,
        'conductor' => true,
        'label' => true,
        'musicbrainz_artistid' => true,
        'musicbrainz_albumid' => true,
        'musicbrainz_albumartistid' => true,
        'musicbrainz_trackid' => true,
        'musicbrainz_releasetrackid' => true,
        'musicbrainz_workid' => true,
        'sampling_frequency' => true,
        'quantization_bits' => true,
        'channels' => true,
        'dsd_rate' => true,
        'album' => true,
    ];

    protected $_virtual = ['initchar'];

    protected function _getInitchar()
    {
        if ( isset( $this->_fields['artist_yomi'] ) ) {
            $res = mb_eregi( "^(The )?(.)", $this->_fields['artist_yomi'], $ret );
            if ( count( $ret ) > 2 ) {
                return $ret[2];
            } else {
                return null;
            }
        } else {
            return null;
        }
    }
}
