<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;
/**
 * Artistnames Model
 *
 * @method \App\Model\Entity\Artistname newEmptyEntity()
 * @method \App\Model\Entity\Artistname newEntity(array $data, array $options = [])
 * @method \App\Model\Entity\Artistname[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Artistname get($primaryKey, $options = [])
 * @method \App\Model\Entity\Artistname findOrCreate($search, ?callable $callback = null, $options = [])
 * @method \App\Model\Entity\Artistname patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Artistname[] patchEntities(iterable $entities, array $data, array $options = [])
 * @method \App\Model\Entity\Artistname|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Artistname saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Artistname[]|\Cake\Datasource\ResultSetInterface|false saveMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Artistname[]|\Cake\Datasource\ResultSetInterface saveManyOrFail(iterable $entities, $options = [])
 * @method \App\Model\Entity\Artistname[]|\Cake\Datasource\ResultSetInterface|false deleteMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Artistname[]|\Cake\Datasource\ResultSetInterface deleteManyOrFail(iterable $entities, $options = [])
 *
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class ArtistnamesTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void
    {
        parent::initialize($config);
        $this->setTable('artistnames');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
        $this->addBehavior('Timestamp');
    }
    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator
    {

        $validator
            ->scalar('kanji')
            ->allowEmptyString('kanji');

        $validator
            ->scalar('yomi')
            ->allowEmptyString('yomi');

        return $validator;
    }
}
