<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * InitialLetters Model
 *
 * @method \App\Model\Entity\InitialLetter newEmptyEntity()
 * @method \App\Model\Entity\InitialLetter newEntity(array $data, array $options = [])
 * @method \App\Model\Entity\InitialLetter[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\InitialLetter get($primaryKey, $options = [])
 * @method \App\Model\Entity\InitialLetter findOrCreate($search, ?callable $callback = null, $options = [])
 * @method \App\Model\Entity\InitialLetter patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\InitialLetter[] patchEntities(iterable $entities, array $data, array $options = [])
 * @method \App\Model\Entity\InitialLetter|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\InitialLetter saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\InitialLetter[]|\Cake\Datasource\ResultSetInterface|false saveMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\InitialLetter[]|\Cake\Datasource\ResultSetInterface saveManyOrFail(iterable $entities, $options = [])
 * @method \App\Model\Entity\InitialLetter[]|\Cake\Datasource\ResultSetInterface|false deleteMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\InitialLetter[]|\Cake\Datasource\ResultSetInterface deleteManyOrFail(iterable $entities, $options = [])
 *
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class InitialLettersTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void
    {
        parent::initialize($config);
        $this->setTable('initial_letters');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
        $this->addBehavior('Timestamp');
    }
    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator
    {
        $validator
            ->nonNegativeInteger('id')
            ->allowEmptyString('id', null, 'create');

        $validator
            ->allowEmptyString('onechar', '１文字のみ入力してください', false )
            ->add(
                'onechar',
                'valid',
                [
                    'rule' => [$this, 'onelenght'],
                    'message' => '１文字のみ入力してください'
                ]
            );

        return $validator;
    }
    public function onelenght($value, $context)
    {
        $ln = mb_strlen($value);
        if ($ln == 1) {
            return true;
        } else {
            return false;
        }
    }
}
