<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Mpdstats Model
 *
 * @method \App\Model\Entity\Mpdstat newEmptyEntity()
 * @method \App\Model\Entity\Mpdstat newEntity(array $data, array $options = [])
 * @method \App\Model\Entity\Mpdstat[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Mpdstat get($primaryKey, $options = [])
 * @method \App\Model\Entity\Mpdstat findOrCreate($search, ?callable $callback = null, $options = [])
 * @method \App\Model\Entity\Mpdstat patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Mpdstat[] patchEntities(iterable $entities, array $data, array $options = [])
 * @method \App\Model\Entity\Mpdstat|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Mpdstat saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Mpdstat[]|\Cake\Datasource\ResultSetInterface|false saveMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Mpdstat[]|\Cake\Datasource\ResultSetInterface saveManyOrFail(iterable $entities, $options = [])
 * @method \App\Model\Entity\Mpdstat[]|\Cake\Datasource\ResultSetInterface|false deleteMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Mpdstat[]|\Cake\Datasource\ResultSetInterface deleteManyOrFail(iterable $entities, $options = [])
 */
class MpdstatsTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void
    {
        parent::initialize($config);

        $this->addBehavior('Timestamp');

        $this->setTable('mpdstats');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator
    {

        $validator
            ->integer('lastdates')
            ->allowEmptyString('lastdates');

        $validator
            ->integer('artisits')
            ->allowEmptyString('artisits');

        $validator
            ->integer('songs')
            ->allowEmptyString('songs');

        $validator
            ->integer('albums')
            ->allowEmptyString('albums');

        $validator
            ->integer('yomifile')
            ->allowEmptyString('yomifile');

        return $validator;
    }
}
