<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;
/**
 * Netradios Model
 *
 * @method \App\Model\Entity\Netradio newEmptyEntity()
 * @method \App\Model\Entity\Netradio newEntity(array $data, array $options = [])
 * @method \App\Model\Entity\Netradio[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Netradio get($primaryKey, $options = [])
 * @method \App\Model\Entity\Netradio findOrCreate($search, ?callable $callback = null, $options = [])
 * @method \App\Model\Entity\Netradio patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Netradio[] patchEntities(iterable $entities, array $data, array $options = [])
 * @method \App\Model\Entity\Netradio|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Netradio saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Netradio[]|\Cake\Datasource\ResultSetInterface|false saveMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Netradio[]|\Cake\Datasource\ResultSetInterface saveManyOrFail(iterable $entities, $options = [])
 * @method \App\Model\Entity\Netradio[]|\Cake\Datasource\ResultSetInterface|false deleteMany(iterable $entities, $options = [])
 * @method \App\Model\Entity\Netradio[]|\Cake\Datasource\ResultSetInterface deleteManyOrFail(iterable $entities, $options = [])
 *
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class NetradiosTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void
    {
        parent::initialize($config);
        $this->setTable('netradios');
        $this->setDisplayField('title');
        $this->setPrimaryKey('id');
        $this->addBehavior('Timestamp');
    }
    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator
    {
        $validator
            ->nonNegativeInteger('id')
            ->allowEmptyString('id', null, 'create');

        $validator
            ->scalar('radiourl')
            ->maxLength('radiourl', 200)
            ->allowEmptyString('radiourl', 'ストリームURLを入力してください',false)
            ->add('radiourl', 'valid', ['rule' => ['url'], 'message' => 'ストリームURLを入力してください']);

        $validator
            ->scalar('title')
            ->maxLength('title', 200)
            ->allowEmptyString('title' , '局名を入力してください', false);

        return $validator;
    }
}
