

<nav class="navbar navbar-inverse navbar-fixed-top">
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                <span class="sr-only">mpcbridge</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <?php echo $this->Html->link(
                '選曲メニュー',
                [ 'controller' => 'browse', 'action' => 'browse', ],
                [ 'class' => 'navbar-brand' ]
            );
            ?>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
<?php if ( $backdir != null ) : ?>
            <ul class="nav navbar-nav">
                <li>
                        <?php
                        echo $this->Html->link(
                            '<span class="glyphicon glyphicon-circle-arrow-left" aria-hidden=true></span>&nbsp;戻る',
                            [ 'controller' => 'browse', 'action' => 'browse', $backdir ],
                            [ 'escape' => FALSE, 'class' => 'btn' ]
                        );
                        ?>
                </li>
            </ul>
<?php endif; ?>
<?php if ( ( $backdir != null ) && ( $backdir != "." ) ) : ?>
            <ul class="nav navbar-nav navbar-right">
                <li><?php echo $this->Html->link(
                        '<span class="glyphicon glyphicon-circle-arrow-up" aria-hidden=true></span>&nbsp;トップ',
                        [ 'controller' => 'browse', 'action' => 'browse', ],
                        [ 'escape' => FALSE, 'role' => 'button', 'class' => 'btn' ]
                    );
                ?></li>
            </ul>
<?php endif; ?>
        </div><!--/.nav-collapse -->
    </div>
</nav>

<?php echo $this->element( 'footer_menu', [ 'ct' => $this->request->getParam('controller'), 'ac' => $this->request->getParam('action') ] ); ?>


<div class="container">
	<div class="json-error alert alert-danger" role="alert"></div>
    <div class="json-message alert alert-success" role="alert"></div>

	<div class="row">

		<h3><?php echo $this->Sanitize->htmlall( $title ); ?></h3>
<?php if ( ! empty( $drlist ) ) : ?>
		<div class="list-group directorylist">
<?php
	$ct = 0;
	foreach ( $drlist as $oneDir ) :
		$dirname = $oneDir[0];
?>
<?php echo $this->Html->link( '<span class="glyphicon glyphicon-folder-open" aria-hidden=true></span> '. $oneDir[0], [ 'action' => 'browse', $oneDir[1] ], [ 'escape' => FALSE, 'class' => 'list-group-item' ] ); ?>

<?php
		$ct ++;
	endforeach;
?>

		</div>
<?php endif; ?>

<?php
	if ( ! empty( $songlist ) ) :
		$filepath = basename( $fradddir );
		if ( isset( $songlist[0]['Album'] ) ) {
			$albmtitle = $songlist[0]['Album'];
		} else {
			$albmtitle = $filepath;
		}
		$artist = "--";
		if ( isset( $songlist[0]['Artist'] ) ) {
			$artist = $songlist[0]['Artist'];
		}
		$albumPath = urlencode( $fradddir );
?>
		<ul class="list-group">
			<li class="list-group-item active albumtitle">
				<div data-toggle="modal" data-target="#AlbumPlay" data-image="<?php echo $albumPath; ?>" data-path="<?php echo $this->Sanitize->htmlall( $albumPath ); ?>" data-albumtitle="<?php echo $this->Sanitize->htmlall( $albmtitle ); ?>" class="forios">
					<?php echo $this->Html->image( $cover_url ."/getimage.php?sml=1&dir=". $albumPath ); ?>
					<h4 class="list-group-item-heading">💿&nbsp;&nbsp;<?php echo $this->Sanitize->htmlall( $albmtitle ); ?></h4>
					<p class="list-group-item-text">🎸&nbsp;&nbsp;<?php echo $this->Sanitize->htmlall( $artist ); ?></p>
				</div>
			</li>

<?php
	$sg = 0;
	foreach ( $songlist as $song ) :
		$sgf = urlencode( $song['file'] );
		$artist = $album = $playTime = "--";
        $format = $composer = '';
        if ( isset($song['duration']) ) {
            $playTime = $this->Tools->sec2minutes( $song['duration'] );
        } elseif ( isset($song['Time']) ) {
            $playTime = $this->Tools->sec2minutes( $song['Time'] );
        }
        if ( isset($song['Format']) ) $format = $this->Tools->arrangeFormat( $song['Format'] );

		if ( isset($song['Title']) ) {
			$title = $song['Title'];
			if ( isset($song['Artist']) ) $artist = $song['Artist'];
			if ( isset($song['Album']) ) $album = $song['Album'];
		} else {
			$fns = explode( "/", $song['file'] );
			$title = array_pop( $fns );
		}
		if ( isset( $song['Composer'] ) && ( $song['Composer'] != '' ) ) $composer = $song['Composer'];
?>
			<li href="#" class="list-group-item">
				<div id="sg<?php echo $sg;?>" data-toggle="modal" data-target="#onePlay" data-file="<?php echo $this->Sanitize->htmlall( $sgf ); ?>" data-title="<?php echo $this->Sanitize->htmlall( $title ); ?>" data-artis="<?php echo $this->Sanitize->htmlall( $artist ); ?>" data-album="<?php echo $this->Sanitize->htmlall( $album ); ?>" data-time="<?php echo $this->Sanitize->htmlall( $playTime ); ?>" class="forios">
					<h4 class="list-group-item-heading">🎵&nbsp;&nbsp;<?php echo $this->Sanitize->htmlall( $title ); ?></h4>
					<p class="list-group-item-text">
<?php
    $have_art = false;
    if ( $artist != "" ) :
        $have_art = true;
?>
						🎸&nbsp;<?php echo $this->Sanitize->htmlall( $artist ) ."\n"; ?>
<?php endif; ?>
<?php
    if ( $composer != "" ) :
        if ( $have_art ) echo "　";
?>
                        🎼&nbsp;<?php echo $this->Sanitize->htmlall( $composer ) ."\n"; ?>
<?php endif; ?>

                        <span class="playtime">🕒&nbsp;<?php echo $playTime; ?><?php
                            if ( $have_format ) :
                                ?><br>🔈&nbsp;<?= $format;?><?php
                            endif; ?></span>
					</p>
<?php if ( $album != "" ) : ?>
					<p class="list-group-item-text">💿&nbsp;<?php echo $this->Sanitize->htmlall( $album ); ?></p>
<?php endif; ?>

				</div>
			</li>

<?php
		$sg ++;
	endforeach;
?>


		</ul>

<div class="modal fade" role=dialog id="AlbumPlay" tabindex="-1" aria-labelledby="albumPlayLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
				<h4 id="onePlayLabel">すべての曲（アルバム）を再生します</h4>
			</div>
			<div class="modal-body dirinfo">
				<h4 class="modal-dirimage"></h4>
				<p class="modal-diralbum"></p>
			</div>
			<div class="modal-footer tocenter">
				<a href="#" onclick="" class="btn btn-default" href="#" role="button" id="adddirwcl">現在の再生リストを削除して追加</a>
				<a href="#" onclick="" class="btn btn-primary" href="#" role="button" id="adddir">現在の再生リストに追加</a>
			</div>
		</div>
	</div>
</div>

<div class="modal fade" role=dialog id="onePlay" tabindex="-1" aria-labelledby="onePlayLabel">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
				<h4 id="onePlayLabel">以下の曲を再生します</h4>
			</div>
			<div class="modal-body">
				<h4 class="modal-title"></h4>
				<p class="modal-artist"></p>
				<p class="modal-album"></p>
				<p class="modal-time"></p>
			</div>
			<div class="modal-footer tocenter">
				<a href="#" onclick="" class="btn btn-default" href="#" role="button" id="addonewcl">現在の再生リストを削除して追加</a>
				<a href="#" onclick="" class="btn btn-primary" href="#" role="button" id="addone">現在の再生リストに追加</a>
			</div>
		</div>
	</div>
</div>

<?php endif; ?>

	</div>

</div>

<?php echo $this->element( 'api_scripts' ); ?>

