
<nav class="navbar navbar-inverse navbar-fixed-top">
    <div class="container">
        <div id="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
                <span class="sr-only">mpcbridge</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
            <ul class="nav navbar-nav">
                <li>
                    <?php
                    echo $this->Html->link(
                        '<span class="glyphicon glyphicon-circle-arrow-left" aria-hidden=true></span>&nbsp;戻る',
                        [ 'controller' => 'browse', 'action' => 'index', ],
                        [ 'escape' => false, 'class' => 'btn' ]
                    );
                    ?>
                </li>
            </ul>
            <ul class="nav navbar-nav navbar-right">
                <li><?php echo $this->Html->link(
                        '<span class="glyphicon glyphicon-circle-arrow-up" aria-hidden=true></span>&nbsp;再検索',
                        [ 'action' => 'index', ],
                        [ 'escape' => false, 'role' => 'button', 'class' => 'btn' ]
                    ); ?></li>
            </ul>
        </div>
    </div>
</nav>

<?php echo $this->element( 'footer_menu', [ 'ct' => $this->request->getParam('controller'), 'ac' => $this->request->getParam('action') ] ); ?>



<div class="container" id="mainbody">
    <div class="json-error alert-danger" role="alert"></div>
    <div class="json-message alert alert-success" role="alert"></div>

    <h3>フリーワード検索</h3>
    <dl class="dl-horizontal">
        <dt>アーティスト名</dt>
        <dd><?php
            if ( strlen( $data['artist_name'] ) > 0 ) {
                echo $this->Sanitize->htmlall( $data['artist_name'] );
            } else {
                echo "未入力";
            } ?></dd>
        <dt>アーティスト名:検索方法</dt>
        <dd><?php
            if ( isset( $s_song[ $data['artist_method'] ] ) ) {
                echo $this->Sanitize->htmlall( $s_artist[ $data['artist_method'] ] );
            } else {
                echo "未選択";
            } ?></dd>
        <dt>曲名</dt>
        <dd><?php
            if ( strlen( $data['song_title'] ) > 0 ) {
                echo $this->Sanitize->htmlall( $data['song_title'] );
            } else {
                echo "未入力";
            } ?></dd>
        <dt>曲名:検索方法</dt>
        <dd><?php
            if ( isset( $s_song[ $data['song_method'] ] ) ) {
                echo $this->Sanitize->htmlall( $s_song[ $data['song_method'] ] );
            } else {
                echo "未選択";
            } ?></dd>
        <dt>ジャンル</dt>
        <dd><?php
            if ( strlen( $data['genre'] ) > 0 ) {
                echo $this->Sanitize->htmlall( $data['genre'] );
            } else {
                echo "未入力";
            } ?></dd>
        <dt>年</dt>
        <dd><?php
            if ( strlen( $data['song_year'] ) > 0 ) {
                echo $this->Sanitize->htmlall( $data['song_year'] );
            } else {
                echo "未入力";
            } ?></dd>
        <dt>作曲家</dt>
        <dd><?php
            if ( strlen( $data['composer'] ) > 0 ) {
                echo $this->Sanitize->htmlall( $data['composer'] );
            } else {
                echo "未入力";
            } ?></dd>
        <dt>音声フォーマット</dt>
        <dd><?php
            if ( isset( $s_format[ $data['song_format'] ] ) ) {
                echo $this->Sanitize->htmlall( $s_format[ $data['song_format'] ] );
            } else {
                echo "全て";
            } ?></dd>
    </dl>

    <div>

        <!-- Nav tabs -->
        <ul class="nav nav-tabs" id="mptab" role="tablist">
            <li role="presentation" class="active"><a href="#albums" aria-controls="albums" role="tab" data-toggle="tab">📀 アルバム一覧</a></li>
            <li role="presentation"><a href="#songs" aria-controls="songs" role="tab" data-toggle="tab">🎵 楽曲一覧</a></li>
        </ul>

        <!-- Tab panes -->
        <div class="tab-content">
            <div role="tabpanel" class="tab-pane active" id="albums">

                <div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">
                    <?php
                    $al = 0;
                    foreach ( $all_albumdata as $albm ) :
                        $pnid = "heading". sprintf( "%04d", $al );
                        $pcid = "collapse". sprintf( "%04d", $al );
                        $alblabel = "albumlabel". sprintf( "%010d", $albm->id );
                        $albumPath = urlencode( $albm->path );

                        ?>
                        <div class="panel panel-default">
                            <div class="albumlisthead forios" data-toggle="modal" data-target="#AlbumPlay" data-image="<?= $albumPath; ?>" data-path="<?= $albumPath; ?>" data-albumtitle="<?= $albm->albumtitle; ?>">
                                <h3 class="panel-title">
                                    <?php echo $this->Html->image( $cover_url ."/getimage.php?sml=1&dir=". $albumPath, [ 'class' => 'albumcover' ] ); ?>
                                    <span class="attl">　💿&nbsp;<?= $albm->albumtitle; ?></span>
                                </h3>
                            </div>
                            <div class="panel-heading" role="tab" id="<?= $pnid; ?>">
                                <a class="sglist" role="button" data-toggle="collapse" data-parent="#accordion" href="#<?= $pcid; ?>" aria-expanded="true" aria-controls="<?= $pcid; ?>">
                                    <span class="glyphicon glyphicon-list" aria-hidden="true"></span> 曲リスト
                                </a>

                                <div class="dropdown songlabel">
                                    <button id="<?php echo $alblabel; ?>" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <?php echo $this->Html->tag( 'span', $albm->favolabel['colorname'], [ 'style' => 'color: '. $albm->favolabel['colorcode'], 'class' => 'selectedlabel' ] ); ?><span class="caret"></span>
                                    </button>
                                    <ul class="dropdown-menu songlabel" aria-labelledby="<?php echo $alblabel; ?>">
                                        <?php
                                        $kk = 0;
                                        $liclass = "";
                                        foreach ($labelname as $lkey => $label ) :
                                            if ( $albm['favolabels_key'] == $lkey ) {
                                                $lblclr = ' style="color: #eee"';
                                            } else {
                                                $lblclr = "";
                                            }
                                            $newColor = $labelcolor[ $lkey ];

                                            if ( $kk != 0 ) $liclass = ' class="labellist"';
                                            ?>
                                            <li<?php echo $liclass; ?><?php echo $lblclr; ?>><?php
                                                echo $this->Html->link( $label, "#", [ 'onclick' => "setnewlabel( {$albm->id},{$lkey},'{$alblabel}' )", 'style' => 'color: '. $newColor, ] );
                                                ?></li>
                                            <?php
                                            $kk ++;
                                        endforeach;
                                        ?>
                                    </ul>
                                </div>
                            </div>
                            <div id="<?php echo $pcid; ?>" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="<?php echo $pnid; ?>">
                                <div class="panel-body songlistinalbum">
                                    <ul class="list-group">
                                        <?php
                                        $alsg = 0;
                                        foreach ( $albm->songs as $alb_song ) :
                                            if ( $alb_song->title == "" ) {
                                                $sng = explode( "/", $alb_song->file );
                                                $songtitle = array_pop( $sng );
                                            } else {
                                                $songtitle = $alb_song->title;
                                            }
                                            $sf = $alb_song->file;

                                            $sgf = urlencode( $sf );
                                            $artist = $playTime = $albumtitle = "--";
                                            $fileFormat = $composer = '';
                                            if ( $alb_song->artist != "" ) $artist = $alb_song->artist;
                                            if ( $alb_song->albumtitle != "" ) $albumtitle = $alb_song->albumtitle;
                                            if ( $alb_song->length != "" ) $playTime = $this->Tools->sec2minutes( $alb_song->length );
                                            if ( $alb_song->fileformat != "" ) $fileFormat = $this->Tools->arrangeFormat( $alb_song->fileformat );
                                            if ( $alb_song->composer != '' ) $composer = $alb_song->composer;
                                            ?>
                                            <li class="list-group-item">
                                                <div>
                                                    <h4 class="list-group-item-heading">🎵&nbsp;<?= $songtitle; ?></h4>
                                                    <p class="list-group-item-text"><?php if ( $artist != "" ) : ?>🎸&nbsp;<?= $artist; ?><?php endif; ?><?php if ( $composer != '' ) : ?>　🎼&nbsp;<?= $composer; ?><?php endif; ?>
                                                        <span class="playtime">🕒&nbsp;<?= $playTime; ?><?php
                                                            if ( $have_format ) :
                                                                ?><br>🔈&nbsp;<?= $fileFormat;?><?php
                                                            endif; ?></span></p>
                                                    <?php if ( $albumtitle != "" ) : ?><p class="list-group-item-text">💿&nbsp;<?= $albumtitle; ?></p><?php endif; ?>

                                                </div>
                                            </li>

                                            <?php
                                            $alsg ++;
                                        endforeach;
                                        ?>

                                    </ul>
                                </div>
                            </div>
                        </div>
                        <?php
                        $al ++;
                    endforeach;
                    ?>
                </div>

            </div>

            <div role="tabpanel" class="tab-pane" id="songs">
                <ul class="list-group">
                    <li class="list-group-item active">
                        <div data-toggle="modal" data-target="#AllSongPlay" class="forios">全曲追加</div>
                    </li>


                    <?php
                    $sg = 0;
                    foreach ( $allsong as $song ) :
                        if ( $song->title == "" ) {
                            $sng = explode( "/", $song->file );
                            $songtitle = array_pop ( $sng );
                        } else {
                            $songtitle = $song->title;
                        }
                        $sf = $song->file;

                        $sgf = urlencode( $sf );
                        $artist = $playTime = $albumtitle = "";
                        $fileFormat = $composer = '';
                        if ( $song->artist != "" ) $artist = $song->artist;
                        if ( $song->albumtitle != "" ) $albumtitle = $song->albumtitle;
                        if ( $song->length != "" ) $playTime = $this->Tools->sec2minutes( $song->length );
                        if ( $song->fileformat != "" ) $fileFormat = $this->Tools->arrangeFormat( $song->fileformat );
                        if ( $song->composer != '' ) $composer = $song->composer;

                        ?>
                        <li href="#" class="list-group-item">

                            <div id="sg<?php echo $sg;?>" data-toggle="modal" data-target="#onePlay" data-file="<?= $sgf; ?>" data-title="<?= $songtitle; ?>" data-artis="<?= $artist; ?>" data-album="<?= $albumtitle; ?>" data-time="<?= $playTime; ?>" class="forios">
                                <h4 class="list-group-item-heading">🎵&nbsp;<?= $songtitle; ?></h4>
                                <p class="list-group-item-text"><?php if ( $artist != "" ) : ?>🎸&nbsp;<?= $artist; ?><?php endif; ?><?php if ( $composer != '' ) : ?>　🎼&nbsp;<?= $composer; ?><?php endif; ?>
                                    <?php if ( $playTime != "" ) : ?><span class="playtime">🕒&nbsp;<?= $playTime ?><?php
                                        if ( $fileFormat != '' ) :
                                            ?><br>🔈&nbsp;<?= $fileFormat;?><?php
                                        endif; ?></span><?php endif; ?></p>
                                <?php if ( $albumtitle != "" ) : ?><p class="list-group-item-text">💿&nbsp;<?= $albumtitle ?></p><?php endif; ?>

                            </div>
                        </li>
                        <?php
                        $sg ++;
                    endforeach;
                    ?>
                </ul>
            </div>
        </div>

        <div class="modal fade" role=dialog id="AlbumPlay" tabindex="-1" aria-labelledby="albumPlayLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                        <h4 id="onePlayLabel">すべての曲（アルバム）を再生します</h4>
                    </div>
                    <div class="modal-body dirinfo">
                        <h4 class="modal-dirimage"></h4>
                        <p class="modal-diralbum"></p>
                    </div>
                    <div class="modal-footer tocenter">
                        <a href="#" onclick="" class="btn btn-default" href="#" role="button" id="adddirwcl">現在の再生リストを削除して追加</a>
                        <a href="#" onclick="" class="btn btn-primary" href="#" role="button" id="adddir">現在の再生リストに追加</a>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" role=dialog id="AllSongPlay" tabindex="-1" aria-labelledby="allPlayLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                        <h4 id="onePlayLabel">検索結果のすべての曲を再生します</h4>
                    </div>

                    <div class="modal-footer tocenter">
                        <a href="#" onclick="" class="btn btn-default" href="#" role="button" id="addallsongswcl">現在の再生リストを削除して追加</a>
                        <a href="#" onclick="" class="btn btn-primary" href="#" role="button" id="addallsongs">現在の再生リストに追加</a>
                        <?php echo $this->Form->create( null, [ 'url' => [ 'action' => 'playall' ], 'type' => 'post', 'id' => "searchwords", ] ) ."\n"; ?>

                        <?php echo $this->Form->input( 'artist_name', [ 'type' => 'hidden', 'value' => $data['artist_name'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'artist_method', [ 'type' => 'hidden', 'value' => $data['artist_method'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'song_title', [ 'type' => 'hidden', 'value' => $data['song_title'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'song_method', [ 'type' => 'hidden', 'value' => $data['song_method'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'song_year', [ 'type' => 'hidden', 'value' => $data['song_year'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'genre', [ 'type' => 'hidden', 'value' => $data['genre'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'composer', [ 'type' => 'hidden', 'value' => $data['composer'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'sortodr', [ 'type' => 'hidden', 'value' => $data['sortodr'] ] ) ."\n"; ?>
                        <?php echo $this->Form->input( 'adtyp', [ 'type' => 'hidden', 'value' => "", 'id' => 'adtyp' ] ) ."\n"; ?>
                        <?php echo $this->Form->end( ); ?>

                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" role=dialog id="onePlay" tabindex="-1" aria-labelledby="onePlayLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                        <h4 id="onePlayLabel">以下の曲を再生します</h4>
                    </div>
                    <div class="modal-body">
                        <h4 class="modal-title"></h4>
                        <p class="modal-artist"></p>
                        <p class="modal-album"></p>
                        <p class="modal-time"></p>
                    </div>
                    <div class="modal-footer tocenter">
                        <a href="#" class="btn btn-default" role="button" id="addonewcl">現在の再生リストを削除して追加</a>
                        <a href="#" class="btn btn-primary" role="button" id="addone">現在の再生リストに追加</a>
                    </div>
                </div>
            </div>
        </div>

    </div>

</div>

<script>

    $('#mptab a').click(function (e) {
        e.preventDefault();
        $(this).tab('show');
    });

    function setnewlabel( albmid, lblid, ulid ) {

        $.ajax( {
            url: '<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'setlabel' ] ); ?>',
            type: 'get',
            data: ( 'alid=' + albmid + '&lbl=' + lblid ),
            dataType: 'json',
            success: function( json ){
                var targetlbl = "#" + ulid + " span.selectedlabel";
                $( targetlbl ).css( 'color', json.result.color );
                $( targetlbl ).empty().text( json.result.name );
            },
            fail: function( json ){
                popupError( '' );
            }
        } );
        return false;
    };

    $('#addallsongswcl').click(function() {
        $('#adtyp').val('c');
        var postData = {};
        $('form#searchwords').find(':input').each(function(){
            postData[$(this).attr('name')] = $(this).val();
        });
        $.ajax( {
            url:		'<?php echo $this->Url->build( [ 'action'=>'playall' ] ); ?>',
            dataType:	'json',
            type:		'post',
            cache:		false,
            data:		postData,
            success:	function( data ) {
                if ( ! data.result ) {
                    popupError( "" );
                } else {
                    popupSuccess( );
                }
            }
        }).fail( function( XMLHttpRequest, textStatus, errorThrown ) {
            popupError( "" );
        });
        $('#AllSongPlay').modal('hide');
        return false;
    });

    $('#addallsongs').click(function() {
        $('#adtyp').val('a');
        var postData = {};
        $('form#searchwords').find(':input').each(function(){
            postData[$(this).attr('name')] = $(this).val();
        });
        $.ajax( {
            url:		'<?php echo $this->Url->build( [ 'action'=>'playall' ] ); ?>',
            dataType:	'json',
            type:		'post',
            cache:		false,
            data:		postData,
            success:	function( data ) {
                if ( ! data.result ) {
                    popupError( "" );
                } else {
                    popupSuccess( );
                }
            }
        }).fail( function( XMLHttpRequest, textStatus, errorThrown ) {
            popupError( "" );
        });
        $('#AllSongPlay').modal('hide');
        return false;
    });

    $(document).ready(function(){
        $('.collapse').collapse( 'hide' );
    });

</script>

<?php echo $this->element( 'api_scripts' ); ?>
