<html lang="ja">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>mpcbridge</title>
    <?php echo $this->Html->css('bootstrap.min.css') ."\n"; ?>
    <?php echo $this->Html->css('jquery-ui.min.css') ."\n"; ?>
    <?php echo $this->Html->css('top.css') ."\n"; ?>

    <?php echo $this->Html->script("jquery-1.12.1.min.js") ."\n"; ?>
    <?php echo $this->Html->script("jquery-ui.min.js") ."\n"; ?>
    <?php echo $this->Html->script("bootstrap.min.js") ."\n"; ?>

    <?php
        echo $this->Html->meta([
            'link' => '/manifest.json',
            'rel' => 'manifest'
        ]);
    ?>

</head>
<body id="mainbody">

<?php echo $this->element( 'footer_menu', [ 'ct' => $this->request->getParam('controller'), 'ac' => $this->request->getParam('action') ] ); ?>

<div class="container" id="mainbody">

    <div class="row row-offcanvas row-offcanvas-left" id="bgimage">

        <div id="infomation">
            <div class="json-error"></div>
            <h4 id="playstat"></h4>
            <div class="songinfo">
                <h3 id="songtitle" class="onechr ssearch" data-songtitle="1" data-strs=""></h3>
                <h4 id="albumtitle" class="onechr" data-albumtitle="1"></h4>
                <h4 id="artist" class="onechr tsearch" data-artist="1" data-strs=""></h4>
                <div id="songmoreinfo" class="extdinfo">
                    <h4 id="songlength" data-songlength="0"></h4>
                    <h4 id="composer" data-composer="0"></h4>
                    <h4 id="songyear" data-songyear="0"></h4>
                    <h4 id="genre" data-genre="0"></h4>
                    <h4 id="bitrate" data-bitrate="0"></h4>
                    <h4 id="samplerate" data-samplerate="0"></h4>
                </div>
                <div id="nextsongblock" class="nextinfo">
                    <p>次の曲：</p>
                    <h4 id="nextsongtitle" class="onechr" data-nextsongtitle="1"></h4>
                    <h4 id="nextalbumtitle" class="onechr" data-nextalbumtitle="1"></h4>
                    <h4 id="nextartist" class="onechr" data-nextartist="1"></h4>
                </div>
            </div>

            <div id="slider-range-min" class="songprogress"></div>
            <input type="hidden" id="amount" readonly>
            <input type="hidden" id="songlengthsec" readonly>


            <div class="btn-toolbar" role=toolbar>
                <div class="btn-group">
                    <button type="button" class="btn btn-default" id="playfbck" title="前の曲">
                        <span class="glyphicon glyphicon-fast-backward" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default" id="playbck" title="巻き戻し">
                        <span class="glyphicon glyphicon-backward" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default color-stop" id="playstop" title="停止">
                        <span class="glyphicon glyphicon-stop" aria-hidden=true></span>
                    </button>

                    <button type="button" class="btn btn-default color-play" id="playbtn" title="再生">
                        <span class="glyphicon glyphicon-play" id="playbtnicon" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default" id="playfwd" title="早送り">
                        <span class="glyphicon glyphicon-forward" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default" id="playffwd" title="次の曲">
                        <span class="glyphicon glyphicon-fast-forward" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default forios" id="playsave" data-toggle="modal" data-target="#saveModal">
                        <span class="glyphicon glyphicon-save-file" aria-hidden=true></span>
                    </button>
                    <button type="button" class="btn btn-default" id="repatmodebtn">
                        <span class="glyphicon glyphicon-repeat norepeat" id="repatmodeicon" aria-hidden=true></span><span class="rpmode"></span>
                    </button>
                    <button type="button" class="btn btn-default" id="playrandom">
                        <span class="glyphicon glyphicon-random notshuffle" id="shuffleicon" aria-hidden=true></span>
                    </button>
                </div>
            </div>
        </div>

        <p class="pull-left" id="listbtn">
            <button type="button" class="btn btn-default" data-toggle="offcanvas" id="playlistbtn">再生リスト</button>
        </p>
        <div class="col-xs-6 col-sm-3 sidebar-offcanvas" id="sidebar">
            <ul class="list-group" id="currentplaylist">
                <li class="list-group-item"><span class="badge"></span>再生リストは空です</li>
            </ul>
        </div>

        <!-- Modal -->
        <div class="modal fade" id="saveModal" tabindex="-1" role="dialog" aria-labelledby="saveModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title" id="saveModalLabel">プレイリストを保存します</h4>
                    </div>
                    <?php echo $this->Form->create( $entity, [ 'type' => 'post', 'id' => "saveplaylist" ] ); ?>

                    <div class="modal-body">
                        <?php echo $this->Form->input( 'listname', [ 'type' => 'text', 'placeholder' => 'プレイリスト名', 'div' => 'form-group', 'class' => "form-control", 'label' => [ 'text' => "プレイリスト名", ] ] ); ?>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">キャンセル</button>
                        <button type="submit" name="send" class="btn btn-success">保存</button>
                    </div>
                    <?php echo $this->Form->end( ); ?>

                </div>
            </div>
        </div>

    </div>

</div>


<script>
    function popupError( addMsg ) {
        $(".json-error").empty().text('通信エラーが発生しました' + addMsg );
        $(".json-error:not(:animated)").fadeIn("slow",function(){
            $(this).delay(3000).fadeOut("slow");
        });
        return true;
    };

    $('form#saveplaylist').submit(function(){
        var postData = {};
        $('form#saveplaylist').find(':input').each(function(){
            postData[$(this).attr('name')] = $(this).val();
        });
        $.ajax( {
            url:		'<?php echo $this->Url->build( array( 'controller'=> 'mpdapi', 'action'=>'saveplaylist') ); ?>',
            dataType:	'json',
            type:		'post',
            cache:		false,
            data:		postData,
            success:	function( data ) {
                if ( ! data.result.status ) {
                    popupError( "（"+ data.result.errors +"）" );
                } else {
                }
            }
        }).fail( function( XMLHttpRequest, textStatus, errorThrown ) {
            popupError( "（通信エラーが発生しました）" );
        }).always( function( data ) {
            $('#saveModal').modal('hide');
        });
        return false;
    });

    function setPlayIcon( mpdstats ) {
        if ( mpdstats == 'play' ) {
            $("#playbtnicon").removeClass("glyphicon-play");
            $("#playbtnicon").addClass("glyphicon-pause");
        } else if ( ( mpdstats == 'pause' ) || ( mpdstats == 'stop' ) ) {
            $("#playbtnicon").removeClass("glyphicon-pause");
            $("#playbtnicon").addClass("glyphicon-play");
        }
        return true;
    }
    function pause( ) {
        $.getJSON(
            '<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'pause' ] ); ?>',
            function( data ) {
                if ( ! data.result.status ) {
                    popupError( "pause" );
                } else {
                    setPlayIcon( data.result.status );
                }
            }
        )
            .error(function(event, jqxhr, exception) { popupError( "getJSON" ); });
    };
    function play( ) {
        $.getJSON(
            '<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'play' ] ); ?>',
            function( data ) {
                if ( ! data.result.status ) {
                    popupError( );
                } else {
                    setPlayIcon( data.result.status );
                }
            }
        )
            .error(function(event, jqxhr, exception) { popupError( ); });
    };
    function playbtn( ) {
        $.getJSON(
            '<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'playbtn' ] ); ?>',
            function( data ) {
                if ( ( data.result.status != 'play' ) &&  ( data.result.status != 'pause' ) ) {
                    popupError( "playbtn" );
                } else {
                    setPlayIcon( data.result.status );
                }
            }
        )
            .error(function(event, jqxhr, exception) { popupError( "playbtn" ); });
    };
    function nomarlbtn( jsonapi ) {
        $.getJSON(
            jsonapi,
            function( data ) { if ( ! data.result ) popupError( "nomarlbtn" ); }
        )
            .error(function(event, jqxhr, exception) { popupError( "nomarlbtn" ); });
    }
    function stop( ) {
        var jsonapi = "<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'stop' ] ); ?>";
        nomarlbtn( jsonapi );
    };
    function nextsong( ) {
        var jsonapi = "<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'nextsong' ] ); ?>";
        nomarlbtn( jsonapi );
    };
    function prevsong( ) {
        var jsonapi = "<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'prevsong' ] ); ?>";
        nomarlbtn( jsonapi );
    };
    function seekfw( ) {
        var jsonapi = "<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'seekfw' ] ); ?>";
        nomarlbtn( jsonapi );
    };
    function seekbk( ) {
        var jsonapi = "<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'seekbk' ] ); ?>";
        nomarlbtn( jsonapi );
    };

    function sanitize(c) {
        return $('<div />').text(c).html();
    }

    $("#currentplaylist").on( 'click', 'li span', function () {
        if ( $(this).hasClass("sgls") ) {
            $.ajax( {
                url:		'<?php echo $this->Url->build( [ 'controller' => 'mpdapi', 'action'=>'playsongid' ] ); ?>',
                dataType:	'json',
                type:		'get',
                cache:		false,
                data:		( 'sid=' + $(this).data("pos") ),
                error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                    popupError( "通信エラーが発生しました" );
                },
            } );
        } else if ( $(this).hasClass("deletepos") ) {
            $.ajax( {
                url:		'<?php echo $this->Url->build( [ 'controller' => 'mpdapi', 'action'=>'deletesong' ] ); ?>',
                dataType:	'json',
                type:		'get',
                cache:		false,
                data:		( 'sid=' + $(this).data("pos") ),
                error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                    popupError( "通信エラーが発生しました" );
                },
            } );
        }
    });

    function setRepeatMode( rpsts ) {
        if ( rpsts == "2" ) {
            $(".rpmode").removeClass("mode0");
            $(".rpmode").empty().text("1");
            $("#repatmodeicon").removeClass("norepeat");
        } else if ( rpsts == "1" ) {
            $(".rpmode").removeClass("mode0");
            $(".rpmode").empty().text("A");
            $("#repatmodeicon").removeClass("norepeat");
        } else {
            $(".rpmode").addClass("mode0");
            $(".rpmode").empty();
            $("#repatmodeicon").addClass("norepeat");
        }
    }
    function setRandomMode( rrmsts ) {
        if ( rrmsts == "2" ) {
            $("#shuffleicon").removeClass("notshuffle");
        } else if ( rrmsts == "1" ) {
            $("#shuffleicon").removeClass("notshuffle");
        } else {
            $("#shuffleicon").addClass("notshuffle");
        }
    }
    function setStats( idtag, data, emo ) {
        if ( data == "" ) {
            $( "#"+idtag).empty().hide( );
        } else {
            var dval = $("#"+idtag).data(idtag);
            if ( dval == 1 ) {
                $("#"+idtag).empty().text( emo +' ' + data );
                $("#"+idtag).show( );
            } else {
                $( "#"+idtag).empty().hide( );
            }
        }
    }
    function setStatsPs( idtag, data, emo, poststr ) {
        if ( data == "" ) {
            $( "#"+idtag).empty().hide( );
        } else {
            var dval = $("#"+idtag).data(idtag);
            if ( dval == 1 ) {
                $("#"+idtag).empty().html( emo +' ' + sanitize(data) + poststr );
                $("#"+idtag).show( );
            } else {
                $( "#"+idtag).empty().hide( );
            }
        }
    }
    function setSonginfo() {
        /* 情報表示 */
        var olddata = localStorage.getItem('fields');
        if ( olddata != null ) {
            fielddata = JSON.parse(olddata);
            $.each( fielddata, function (index, value) {
                if ( value == "1" ) {
                    $('h4').data(index, 1);
                }
            } );
        }
    }

    $(document).ready( function() {
        $.support.transition = false
        $('#playstat').hide( );
        $('#playbtn').click( function( ) {
            playbtn( );
        });
        $('#playpause').click( function( ) {
            pause( );
        });
        $('#playfbck').click( function( ) {
            prevsong( );
        });
        $('#playbck').click( function( ) {
            seekbk( );
        });
        $('#playfwd').click( function( ) {
            seekfw( );
        });
        $('#playffwd').click( function( ) {
            nextsong( );
        });
        $('#playstop').click( function( ) {
            stop( );
        });
        $('#repatmodebtn').click( function( ) {
            $.ajax( {
                url:		'<?php echo $this->Url->build( [ 'controller' => 'mpdapi', 'action'=>'repeat' ] ); ?>',
                dataType:	'json',
                type:		'get',
                cache:		false,
                success:	function( data ){
                    setRepeatMode( data.repeat.repeat );
                },
                error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                    popupError( "通信エラーが発生しました" );
                },
            } );

        });
        $('#playrandom').click( function( ) {
            $.ajax( {
                url:		'<?php echo $this->Url->build( [ 'controller' => 'mpdapi', 'action'=>'random' ] ); ?>',
                dataType:	'json',
                type:		'get',
                cache:		false,
                success:	function( data ){
                    setRandomMode( data.random.random );
                },
                error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                    popupError( "通信エラーが発生しました" );
                },
            } );

        });
        $('[data-toggle="offcanvas"]').click(function () {
            $('.row-offcanvas').toggleClass('active');
        });
        $('.ssearch').click( function( ) {
            var strs = $('.ssearch .isearch').data('strs');
            location.href = "<?php echo $this->Url->build( [ 'controller'=> 'isearch', 'action'=>'scsongtitle' ] ); ?>/"+ encodeURI( strs );
        } );
        $('.tsearch').click( function( ) {
            var strs = $('.tsearch .isearch').data('strs');
            location.href="<?php echo $this->Url->build( [ 'controller'=> 'isearch', 'action'=>'scartist' ] ); ?>/" + encodeURI( strs );
        } );

        /*	start up	*/
        $.getJSON(
            '<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'currentstat' ] ); ?>',
            function( data ) {
                var sticon = 'play';
                if ( ( data.status.state == 'pause' ) || ( data.status.state == 'stop' ) ) sticon = 'pause';

                setPlayIcon( sticon );
            }
        ).error(function(event, jqxhr, exception) { popupError( ); });

        /*        曲の進行        */
        $( function loadsong( ) {
            $.ajax( {
                url:		'<?php echo $this->Url->build( [ 'controller'=> 'mpdapi', 'action'=>'getcurrentstatus' ] ); ?>',
                dataType:	'json',
                cache:		false,
                success:	function( data ) {

                    $('#songinfo').show( );
                    var smi = false;
                    if ( window.innerHeight > 600 ) smi = true;
                    /* 再生位置 */
                    var scrt = data.currentsong.timecurrent;	/* 再生中の曲の位置(秒) */
                    var slgt = data.currentsong.timelength;		/* 再生中の曲の長さ(秒) */
                    var position = data.currentsong.Pos;		/* 再生中の曲番 */
                    var npos = ( scrt / slgt ) * 100;
                    $( "#slider-range-min" ).slider( "value", npos );
                    $( "#amount" ).val( $( "#slider-range-min" ).slider( "value" ) );
                    $( "#songlengthsec" ).val( slgt );

                    var onPlay = true;
                    /* 曲情報 */
                    switch( data.currentsong.state ) {
                        case 'play':
                            setStatsPs( "songtitle", data.currentsong.Title, '🎵', ' <span class="isearch" data-strs="'+ data.currentsong.Title +'">🔍</span>' );
                            setStats( "albumtitle", data.currentsong.Album, '💿' );
                            setStatsPs( "artist", data.currentsong.Artist, '🎸', ' <span class="isearch" data-strs="'+ data.currentsong.Artist +'">🔍</span>' );
                            setStats( "songyear", data.currentsong.Date, '🗓' );
                            setStats( "composer", data.currentsong.Composer, '🎼' );
                            setStats( "genre", data.currentsong.Genre, '🎶' );
                            setStats( "bitrate", data.currentsong.bitrate, '💻' );
                            setStats( "samplerate", data.currentsong.audios, '🔊' );
                            setStats( "songlength", data.currentsong.songtime, '🕒' );
                            $('#playstat').empty().text('再生中').show( );
                            $("title").html('再生中:'+data.currentsong.Title);
                            break;

                        case 'pause':
                            setStatsPs( "songtitle", data.currentsong.Title, '🎵', ' <span class="isearch" data-strs="'+ data.currentsong.Title +'">🔍</span>' );
                            setStats( "albumtitle", data.currentsong.Album, '💿' );
                            setStatsPs( "artist", data.currentsong.Artist, '🎸', ' <span class="isearch" data-strs="'+ data.currentsong.Artist +'">🔍</span>' );
                            setStats( "songyear", data.currentsong.Date, '🗓' );
                            setStats( "composer", data.currentsong.Composer, '🎼' );
                            setStats( "genre", data.currentsong.Genre, '🎶' );
                            setStats( "bitrate", data.currentsong.bitrate, '💻' );
                            setStats( "samplerate", data.currentsong.audios, '🔊' );
                            setStats( "songlength", data.currentsong.songtime, '🕒' );
                            $('#playstat').empty().text('一時停止中').show( );
                            $("title").html('一時停止中');
                            break;

                        default:
                            $("#songtitle").empty().text( '停止中' );
                            $("#albumtitle").empty();
                            $("#artist").empty();
                            $("#songyear").empty();
                            $("#composer").empty();
                            $("#genre").empty();
                            $("#bitrate").empty();
                            $("#samplerate").empty();
                            $("#songlength").empty();
                            $("title").html('停止中');
                            onPlay = false;
                            $('#playstat').empty().hide( );
                            break;
                    }

                    setPlayIcon( data.currentsong.state );

                    /* 次の曲 */
                    if ( data.currentsong.nTitle.length > 0 ) {
                        setStats( "nextsongtitle", data.currentsong.nTitle, '🎵' );
                        setStats( "nextalbumtitle", data.currentsong.nAlbum, '💿' );
                        setStats( "nextartist", data.currentsong.nArtist, '🎸' );
                        /*                        $('.nextinfo').show( );*/
                    } else {
                        $('#nextsongtitle').empty( );
                        $('#nextalbumtitle').empty( );
                        $('#nextartist').empty( );
                        $('.nextinfo').hide( );
                    }

                    /* カバーアート */
                    var currentimage = $( '#bgimage' ).css( "background-image" );
                    var matches = currentimage.match(/dir\=(.*)\"/);
                    var oldimage = "";
                    if ( matches != null ) oldimage = matches[1];
                    if ( oldimage != data.currentsong.filepath ) {
                        $( '#bgimage' ).css( "background-image", 'url("<?php
                            $coverimgurl = $this->Url->build( $cover_url . '/getbgimage.php' );
                            echo $coverimgurl; ?>?dir=' + data.currentsong.filepath + '")' );
                    }

                    /* プレイリスト */
                    var songnum = Object.keys(data.playlist).length;
                    var currentHtml = $('#currentplaylist').html( );
                    if ( songnum > 0 ) {
                        var lists = "";
                        $.each( data.playlist, function( ) {
                            var title = sanitize( this.Title );
                            var oneList = "";
                            if ( position == this.Pos ) {
                                oneList = '<li class="list-group-item onplay">';
                                title = '🔊&nbsp;'+ title;
                            } else {
                                oneList = '<li class="list-group-item">';
                            }
                            oneList += '<span class="badge deletepos" data-pos="'+ this.Pos +'">&nbsp;<span class="glyphicon glyphicon-trash" aria-hidden=true></span>&nbsp;</span>';
                            oneList += '<span class="sgls" data-pos="'+ this.Pos +'">' + title + '</span></li>';
                            lists += oneList;
                        } );
                        if ( currentHtml != lists )
                            $('#currentplaylist').empty( ).html( lists );
                    } else {
                        /* 再生リストが空 */
                        $('#currentplaylist').empty( ).html( '<li class="list-group-item">再生リストは空です</li>' );
                    }
                    /* random play mode */
                    var randommode = data.currentsong.random;

                    /* repeat mode */
                    var repeatmode = data.currentsong.repeatmode;
                    setRepeatMode( repeatmode );

                },
                error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                    popupError( "（loadsongでエラーです）" );
                },
                complete:	function() {
                    window.setTimeout(loadsong, 1000);
                }
            });
        });

        $( "#slider-range-min" ).slider( {
            orientation: "horizontal",
            range: "min",
            min: 0,
            max: 100,
            stop: function( event, ui ) {
                var tapval = ui.value;
                var songlength = $('input#songlengthsec').val( );
                var postm = Math.round( tapval * songlength / 100 );
                $.ajax( {
                    url:		'<?php echo $this->Url->build( [ 'controller' => 'mpdapi', 'action'=>'seektime' ] ); ?>/',
                    type:		'get',
                    data:		( 'tm=' + postm ),
                    dataType:	'json',
                    cache:		false,
                    error:		function( XMLHttpRequest, textStatus, errorThrown ) {
                        popupError( "（シークでエラーです）" );
                    }
                } );
            }
        } );

        setSonginfo();
    });

    $( window ).keydown( function( event ) {
        switch ( event.which ) {
            case 32:
                playbtn( );
                break;
            case 39:
                nextsong( );
                break;
            case 37:
                prevsong( );
                break;
            default:
                break;
        }
        return false;
    });


</script>

</body>
</html>