<?php
/*

	Takeo Akiyama, Fourthgate Inc.

	mpcbridge Ver. 5.0 / 2017.02.25

 */

	define( 'USE_GETID3', false );
	define( 'PATH_GETID3', "getid3/getid3.php" );


	$defaultimgfile = "dummy.jpg";
	$defaultimgtype = "image/jpeg";
	$tgimg = "";
	$defaultout = false;

	$getsonginfo = USE_GETID3;
	if ($getsonginfo) {
		try {
			if (! @include_once( PATH_GETID3 )) throw new Exception ('functions.php does not exist');
		} catch (Exception $exc) {
			$getsonginfo = FALSE;
		}

	}


	if ( isset($_GET['fln']) && (trim($_GET['fln'])!="") ) {
//		$fln = urldecode( trim($_GET['fln']) );
		$fln = trim($_GET['fln'] );
//		$fln = str_replace("／／", DIRECTORY_SEPARATOR , $fln );

		$cdr = ".". DIRECTORY_SEPARATOR . dirname($fln);	//	相対パスに変更
		$cfln = ".". DIRECTORY_SEPARATOR . $fln;	//	相対パスに変更
		if (is_dir($cdr) ) {
			//	ファイルから取得する
			if ( $getsonginfo ) {
				if ( is_file( $cfln ) ) {

					$imgtags = NULL;
					$includeimage = FALSE;
					$getID3 = new getID3;
					$fileinfo = $getID3->analyze($cfln);
					if ( isset($fileinfo['audio']) ) {
						$fmt = $fileinfo['audio']['dataformat'];
						switch ( $fmt ) {
							case "flac":
								if ( isset($fileinfo["flac"]["PICTURE"]) && (!empty($fileinfo["flac"]["PICTURE"]))) {
									$imgtmp = array_shift( $fileinfo["flac"]["PICTURE"] );

									if ( isset( $imgtmp[ "image_data" ] ) && ( ! empty($imgtmp[ "image_data" ]) )) {
										$imgtags = $imgtmp[ "image_data" ];
										$includeimage = TRUE;
									} elseif ( isset( $imgtmp[ "data" ] ) && ( ! empty($imgtmp[ "data" ]) )) {
										$imgtags = $imgtmp[ "data" ];
										$includeimage = TRUE;
									}
								} elseif ( isset($fileinfo["flac"]["comments"]["picture"]) ) {
									$imgtmp = array_shift( $fileinfo["flac"]["comments"]["picture"] );
									if  (!empty($imgtmp[ "data" ])) {
										$imgtags = $imgtmp[ "data" ];
										$includeimage = TRUE;
									}
								}
								break;

							case "quicktime":
								if ( isset($fileinfo["tags"]["quicktime"]["artwork"]) ) {
									$imgtags = array_shift( $fileinfo["tags"]["quicktime"]["artwork"] );
									$includeimage = TRUE;
								}
								break;

							case "mp4":
								if ( isset($fileinfo["tags"]["quicktime"]["artwork"]) ) {
									$imgtags = array_shift( $fileinfo["tags"]["quicktime"]["artwork"] );
									$includeimage = TRUE;
								}
								break;

							case "mp3":
								if ( isset($fileinfo["tags"]["id3v2"]["picture"]) ) {
									$imgtmp = array_shift( $fileinfo["tags"]["id3v2"]["picture"] );
									$includeimage = TRUE;
									$imgtags = $imgtmp[ "data" ];
								}
								break;

							default:
								
								break;
						}
						if ($includeimage) {
							$fim = new Imagick( );
							$fim->readImageBlob($imgtags);
							$fim->setImageFormat('jpeg');
							header("Content-Type: image/jpeg");
							echo $fim;
							exit;
						}
					}

				}
			}

			if ( is_file($cdr . DIRECTORY_SEPARATOR ."cover.jpg") && ( ( $iminf = getimagesize($cdr . DIRECTORY_SEPARATOR ."cover.jpg" ) ) !== FALSE ) ) {
				$tgimg =  DIRECTORY_SEPARATOR . "cover.jpg";
			} elseif ( is_file($cdr . DIRECTORY_SEPARATOR ."Cover.jpg") && ( ( $iminf = getimagesize($cdr . DIRECTORY_SEPARATOR ."Cover.jpg" ) ) !== FALSE ) ) {
				$tgimg =  DIRECTORY_SEPARATOR ."Cover.jpg";
			} elseif ( is_file($cdr . DIRECTORY_SEPARATOR ."folder.jpg") && ( ( $iminf = getimagesize($cdr . DIRECTORY_SEPARATOR ."folder.jpg" ) ) !== FALSE ) ) {
				$tgimg =  DIRECTORY_SEPARATOR ."folder.jpg";
			} elseif ( is_file($cdr . DIRECTORY_SEPARATOR ."Folder.jpg") && ( ( $iminf = getimagesize($cdr . DIRECTORY_SEPARATOR ."Folder.jpg" ) ) !== FALSE ) ) {
				$tgimg =  DIRECTORY_SEPARATOR ."Folder.jpg";
			} else {
				//ディレクトリ内のファイル名を１つずつを取得

				//	ディレクトリの場合、ファイルをサーチ
				if ( ( $allfiles = scandir( $cdr, 1 ) ) !== FALSE ) {
					foreach ($allfiles as $one) {
						if ( preg_match("/(.*)\.(jpg|jpeg|png)$/i", $one) ) {
							if ( ( $iminf = getimagesize($cdr . DIRECTORY_SEPARATOR . $one ) ) !== FALSE ) {
								$tgimg = $one;
								break;
							}
						}
					}
				}
			}

		} else {
			$defaultout = TRUE;
		}
		if ( strlen( $tgimg ) > 0 ) {
			$targetimgfile = $cdr . DIRECTORY_SEPARATOR . $tgimg;
			$targetimgtype = $iminf['mime'];

			$ext = preg_split("/\//", $targetimgtype);
			header("Content-Disposition: inline; filename=cover.". $ext[1]);
			header("Cache-Control: private");
			header( 'Content-type: '. $targetimgtype );
			readfile( $targetimgfile );
			exit;
		} else {
			$defaultout = TRUE;
		}
	} else {
		$defaultout = TRUE;;
	}
	if ( $defaultout ) {
		header("Content-Disposition: inline; filename=nocover.jpg");
		header( 'Content-type: '. $defaultimgtype );
		readfile( $defaultimgfile );
	}

?>